<?php
/**
 * @version     1.2.3
 * @package     Virtuemart.Plugin
 * @subpackage  Vmpayment.bifit
 *
 * @copyright   Copyright (C) 2021 BIFIT. All rights reserved.
 * @license     GNU General Public License version 2 or later
 */

defined('_JEXEC') or die();

class plgVmpaymentBifitInstallerScript
{
	function install($parent)
	{
		// подключаемся к базе данных сайта
		$db = JFactory::getDbo();

		// создаём новую таблицу
		$creaTabSql =
			'CREATE TABLE IF NOT EXISTS ' .
			$db->quoteName('#__virtuemart_bifit_reports') .
			' (' .
			$db->quoteName('id') .
			' int(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,' .
			$db->quoteName('order_id') .
			' int(11) NOT NULL,' .
			$db->quoteName('order_number') .
			' varchar(50) NOT NULL,' .
			$db->quoteName('order_date') .
			' datetime NOT NULL DEFAULT "0000-00-00 00:00:00",' .
			$db->quoteName('action_date') .
			' datetime NOT NULL DEFAULT "0000-00-00 00:00:00",' .
			$db->quoteName('receipt_link') .
			' varchar(255) NOT NULL,' .
			$db->quoteName('receipt_id') .
			' int(11) NOT NULL,' .
			$db->quoteName('receipt_type') .
			' varchar(50) NOT NULL,' .
			$db->quoteName('log') .
			' text NOT NULL' .
			') ENGINE=InnoDB';

		if ($db->hasUTF8mb4Support()) {
			$creaTabSql =
				$creaTabSql .
				' DEFAULT CHARSET=utf8mb4 DEFAULT COLLATE=utf8mb4_unicode_ci;';
		} else {
			$creaTabSql =
				$creaTabSql .
				' DEFAULT CHARSET=utf8 DEFAULT COLLATE=utf8_unicode_ci;';
		}

		$db->setQuery($creaTabSql)->execute();

		JFactory::getApplication()->enqueueMessage(
			JText::_(
				'Successfully installed "VirtueMart - BIFIT kassa" plugin!'
			)
		);
	}

	function uninstall($parent)
	{
		// подключаемся к базе данных сайта
		$db = JFactory::getDbo();
		// удаляем таблицу плагина
		$dropTabSql =
			'DROP TABLE ' . $db->quoteName('#__virtuemart_bifit_reports') . ';';
		$db->setQuery($dropTabSql)->execute();

		JFactory::getApplication()->enqueueMessage(
			JText::_(
				'Successfully uninstalled "VirtueMart - BIFIT kassa" plugin!'
			)
		);
	}

	function update($parent)
	{
		// подключаемся к базе данных сайта
		$db = JFactory::getDbo();
		// получаем список всех столбцов таблицы
		$columns = $db->getTableColumns('#__virtuemart_bifit_reports');
		// проверяем наличие в списке нужного столбца
		$column = 'cashier';
		if (array_key_exists($column, $columns)) {
			/// если обнаружен "старый" столбец, то обновляем таблицу до новой версии
			$query =
				'ALTER TABLE ' .
				$db->quoteName('#__virtuemart_bifit_reports') .
				'
				DROP ' .
				$db->quoteName('cashier') .
				',
				DROP ' .
				$db->quoteName('client') .
				',
				DROP ' .
				$db->quoteName('payment_type') .
				',
				DROP ' .
				$db->quoteName('doc') .
				';';
			$db->setQuery($query)->query();
			$query =
				'ALTER TABLE ' .
				$db->quoteName('#__virtuemart_bifit_reports') .
				' 
				ADD ' .
				$db->quoteName('action_date') .
				' DATETIME NOT NULL DEFAULT "0000-00-00 00:00:00" 
				AFTER ' .
				$db->quoteName('order_date') .
				';';
			$db->setQuery($query)->execute();

			JFactory::getApplication()->enqueueMessage(
				JText::_(
					'Successfully updated "VirtueMart - BIFIT kassa" plugin!'
				)
			);
		}
	}
}